<iframe src="../.ibox.html?raw=true" style="border:none; position:fixed; width:40px; right:0; z-index=999;"></iframe>

# Sub-totalling

Another common pattern is to subtotal columns in a table. For this example, `ls` is run on the
_data_ folder. Subtotalling is as simple as _folding_ over a column, summing along the way. It
looks good to _add_ this as an additional row to the table:
```plaintext
ls data | let $t | fold 0 + $row.size | let $total | \$t | append-row 'Total' #n $total
```

The `#n` pads the second column with `Nil` as `size` is the third column along.

## Sub-total multiple columns
---

Let's extend this example to such that we can add a sub-total row for multiple columns:
```plaintext
def sub-total Table (col:Str) { fold 0 + { \$row | get $col 0 } }

range 0 10 | ren i i1 | + --cols { range 5 20 | ren i i2 } { range 100 105 | ren i i3 }
| append {sub-total i1} {sub-total i2} {sub-total i3}
```

> Notice the overload on the `get $col 0`. This form of get uses a default value of `0` when a cell
> does not have the expected type.

![](../assets/adv-pat.subtotal.png?raw=true)
